A. Mahmoud and Longest Uncommon Subsequence
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

While Mahmoud and Ehab were practicing for IOI, they found a problem which name was Longest common subsequence. They solved it, and then Ehab challenged Mahmoud with another problem.

Given two strings a and b, find the length of their longest uncommon subsequence, which is the longest string that is a subsequence of one of them and not a subsequence of the other.

A subsequence of some string is a sequence of characters that appears in the same order in the string, The appearances don't have to be consecutive, for example, strings "ac", "bc", "abc" and "a" are subsequences of string "abc" while strings "abbc" and "acb" are not. The empty string is a subsequence of any string. Any string is a subsequence of itself.

Input

The first line contains string a, and the second line — string b. Both of these strings are non-empty and consist of lowercase letters of English alphabet. The length of each string is not bigger than 105 characters.

Output

If there's no uncommon subsequence, print "-1". Otherwise print the length of the longest uncommon subsequence of a and b.

Examples
Input
abcd
defgh
Output
5
Input
a
a
Output
-1
Note

In the first example: you can choose "defgh" from string b as it is the longest subsequence of string b that doesn't appear as a subsequence of string a.

题意:给你两个字符串 问最长的不公共子序列 不存在则输出-1

题解:两个字符串长度不相等则最长不公共子序列的长度为较长的那个字符串的长度

若两个字符串的长度相等 只有两个字符串完全一致才不存在公共子序列

 1 #include <iostream>
 2 #include <cstdio>
 3 #include <cstdlib>
 4 #include <cstring>
 5 #include <stack>
 6 #include <queue>
 7 #include <cmath>
 8 #include <map>
 9 #define ll __int64
10 using namespace  std;
11 char a[100005];
12 char b[100005];
13 int  main()
14 {
15     scanf("%s",a);
16     scanf("%s",b);
17     int lena=strlen(a);
18     int lenb=strlen(b);
19     if(lena!=lenb)
20     {
21         printf("%d\n",max(lena,lenb));
22     }
23     else
24     {
25         for(int i=0;i<lena;i++)
26         {
27             if(a[i]!=b[i])
28             {
29                 printf("%d\n",lena);
30                 return 0;
31             }
32         }
33         printf("-1\n");
34     }
35     return 0;
36 }

 

 

B. Mahmoud and a Triangle
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

Mahmoud has n line segments, the i-th of them has length ai. Ehab challenged him to use exactly 3 line segments to form a non-degenerate triangle. Mahmoud doesn't accept challenges unless he is sure he can win, so he asked you to tell him if he should accept the challenge. Given the lengths of the line segments, check if he can choose exactly 3 of them to form a non-degenerate triangle.

Mahmoud should use exactly 3 line segments, he can't concatenate two line segments or change any length. A non-degenerate triangle is a triangle with positive area.

Input

The first line contains single integer n (3 ≤ n ≤ 105) — the number of line segments Mahmoud has.

The second line contains n integers a1, a2, ..., an (1 ≤ ai ≤ 109) — the lengths of line segments Mahmoud has.

Output

In the only line print "YES" if he can choose exactly three line segments and form a non-degenerate triangle with them, and "NO" otherwise.

Examples
Input
5
1 5 3 2 4
Output
YES
Input
3
4 1 2
Output
NO
Note

For the first example, he can use line segments with lengths 2, 4 and 5 to form a non-degenerate triangle.

题意:给你n条边 问是否可以从当中选择3条边形成三角形

题解:对边排序 遍历一遍

 1 #include <iostream>
 2 #include <cstdio>
 3 #include <cstdlib>
 4 #include <cstring>
 5 #include <algorithm>
 6 #include <stack>
 7 #include <queue>
 8 #include <cmath>
 9 #include <map>
10 #define ll __int64
11 using namespace  std;
12 int n;
13 int a[100005];
14 int  main()
15 {
16     scanf("%d",&n);
17     for(int i=1;i<=n;i++)
18     {
19         scanf("%d",&a[i]);
20     }
21     sort(a+1,a+1+n);
22     for(int i=n;i>=3;i--)
23     {
24         if(a[i-2]+a[i-1]>a[i])
25         {
26             printf("YES\n");
27             return 0;
28         }
29     }
30     printf("NO\n");
31     return 0;
32 }

 

 

C. Mahmoud and a Message
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

Mahmoud wrote a message s of length n. He wants to send it as a birthday present to his friend Moaz who likes strings. He wrote it on a magical paper but he was surprised because some characters disappeared while writing the string. That's because this magical paper doesn't allow character number i in the English alphabet to be written on it in a string of length more than ai. For example, if a1 = 2 he can't write character 'a' on this paper in a string of length 3 or more. String "aa" is allowed while string "aaa" is not.

Mahmoud decided to split the message into some non-empty substrings so that he can write every substring on an independent magical paper and fulfill the condition. The sum of their lengths should be n and they shouldn't overlap. For example, if a1 = 2 and he wants to send string "aaa", he can split it into "a" and "aa" and use 2 magical papers, or into "a", "a" and "a" and use 3 magical papers. He can't split it into "aa" and "aa" because the sum of their lengths is greater than n. He can split the message into single string if it fulfills the conditions.

A substring of string s is a string that consists of some consecutive characters from string s, strings "ab", "abc" and "b" are substrings of string "abc", while strings "acb" and "ac" are not. Any string is a substring of itself.

While Mahmoud was thinking of how to split the message, Ehab told him that there are many ways to split it. After that Mahmoud asked you three questions:

  • How many ways are there to split the string into substrings such that every substring fulfills the condition of the magical paper, the sum of their lengths is n and they don't overlap? Compute the answer modulo 109 + 7.
  • What is the maximum length of a substring that can appear in some valid splitting?
  • What is the minimum number of substrings the message can be spit in?

Two ways are considered different, if the sets of split positions differ. For example, splitting "aa|a" and "a|aa" are considered different splittings of message "aaa".

Input

The first line contains an integer n (1 ≤ n ≤ 103) denoting the length of the message.

The second line contains the message s of length n that consists of lowercase English letters.

The third line contains 26 integers a1, a2, ..., a26 (1 ≤ ax ≤ 103) — the maximum lengths of substring each letter can appear in.

Output

Print three lines.

In the first line print the number of ways to split the message into substrings and fulfill the conditions mentioned in the problem modulo 109  +  7.

In the second line print the length of the longest substring over all the ways.

In the third line print the minimum number of substrings over all the ways.

Examples
Input
3
aab
2 3 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1
Output
3
2
2
Input
10
abcdeabcde
5 5 5 5 4 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1
Output
401
4
3
Note

In the first example the three ways to split the message are:

  • a|a|b
  • aa|b
  • a|ab

The longest substrings are "aa" and "ab" of length 2.

The minimum number of substrings is 2 in "a|ab" or "aa|b".

Notice that "aab" is not a possible splitting because the letter 'a' appears in a substring of length 3, while a1 = 2.

题意:给你长度为n的小写字母字符串 将字符串按照要求分成各个连续的部分  第三行输入26个数 对于每个字母 例如对于字母a 所在部分的字符串长度不能大于A

问1:方案数%mod,2:分成部分的最长长度,3:最少分成几个部分

题解:dp处理

dp[1][i]=(dp[1][i]+dp[1][j-1])%mod;

dp[2][i]=max(dp[2][i],max(dp[2][j-1],i-j+1));

dp[3][i]=min(dp[3][i],dp[3][j-1]+1);

#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <algorithm>
#include <stack>
#include <queue>
#include <cmath>
#include <map>
#define ll __int64
#define mod 1000000007
using namespace  std;
int n;
char a[1005];
map<char,int>mp;
int dp[5][1005];
int main()
{
    scanf("%d",&n);
    scanf("%s",a+1);
    for(int i=1;i<=26;i++)
    scanf("%d",&mp['a'+i-1]);
    memset(dp[1],0,sizeof(dp[1]));
    for(int i=1;i<=n;i++)
    {
        dp[2][i]=0;
        dp[3][i]=n;
    }
    dp[1][0]=1;
    dp[2][0]=0;
    dp[3][0]=0;
    for(int i=1;i<=n;i++)
    {
        int len=mp[a[i]];
        for(int j=i;j>=1;j--)
        {
          len=min(len,mp[a[j]]);
          if(i-j+1>len) break;
          dp[1][i]=(dp[1][i]+dp[1][j-1])%mod;
          dp[2][i]=max(dp[2][i],max(dp[2][j-1],i-j+1));
          dp[3][i]=min(dp[3][i],dp[3][j-1]+1);
        }
    }
    printf("%d\n%d\n%d\n",dp[1][n],dp[2][n],dp[3][n]);
    return 0;
}

 

D. Mahmoud and a Dictionary
time limit per test
4 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

Mahmoud wants to write a new dictionary that contains n words and relations between them. There are two types of relations: synonymy (i. e. the two words mean the same) and antonymy (i. e. the two words mean the opposite). From time to time he discovers a new relation between two words.

He know that if two words have a relation between them, then each of them has relations with the words that has relations with the other. For example, if like means love and love is the opposite of hate, then like is also the opposite of hate. One more example: if love is the opposite of hate and hate is the opposite of like, then love means like, and so on.

Sometimes Mahmoud discovers a wrong relation. A wrong relation is a relation that makes two words equal and opposite at the same time. For example if he knows that love means like and like is the opposite of hate, and then he figures out that hate means like, the last relation is absolutely wrong because it makes hate and like opposite and have the same meaning at the same time.

After Mahmoud figured out many relations, he was worried that some of them were wrong so that they will make other relations also wrong, so he decided to tell every relation he figured out to his coder friend Ehab and for every relation he wanted to know is it correct or wrong, basing on the previously discovered relations. If it is wrong he ignores it, and doesn't check with following relations.

After adding all relations, Mahmoud asked Ehab about relations between some words based on the information he had given to him. Ehab is busy making a Codeforces round so he asked you for help.

Input

The first line of input contains three integers n, m and q (2 ≤ n ≤ 105, 1 ≤ m, q ≤ 105) where n is the number of words in the dictionary, m is the number of relations Mahmoud figured out and q is the number of questions Mahmoud asked after telling all relations.

The second line contains n distinct words a1, a2, ..., an consisting of small English letters with length not exceeding 20, which are the words in the dictionary.

Then m lines follow, each of them contains an integer t (1 ≤ t ≤ 2) followed by two different words xi and yi which has appeared in the dictionary words. If t = 1, that means xi has a synonymy relation with yi, otherwise xi has an antonymy relation with yi.

Then q lines follow, each of them contains two different words which has appeared in the dictionary. That are the pairs of words Mahmoud wants to know the relation between basing on the relations he had discovered.

All words in input contain only lowercase English letters and their lengths don't exceed 20 characters. In all relations and in all questions the two words are different.

Output

First, print m lines, one per each relation. If some relation is wrong (makes two words opposite and have the same meaning at the same time) you should print "NO" (without quotes) and ignore it, otherwise print "YES" (without quotes).

After that print q lines, one per each question. If the two words have the same meaning, output 1. If they are opposites, output 2. If there is no relation between them, output 3.

See the samples for better understanding.

Examples
Input
3 3 4
hate love like
1 love like
2 love hate
1 hate like
love like
love hate
like hate
hate like
Output
YES
YES
NO
1
2
2
2
Input
8 6 5
hi welcome hello ihateyou goaway dog cat rat
1 hi welcome
1 ihateyou goaway
2 hello ihateyou
2 hi goaway
2 hi hello
1 hi hello
dog cat
dog hi
hi hello
ihateyou goaway
welcome ihateyou
Output
YES
YES
YES
YES
NO
YES
3
3
1
1
2

题意:给你n个字符串 m个字符串间的关系 1代表同义词 2代表反义词 q个询问 1代表同义词 2代表反义词 3代表不确定
题解:并查集处理 需要增加n个点 表示反义词 具体看代码理解
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <algorithm>
#include <stack>
#include <queue>
#include <cmath>
#include <map>
#define ll __int64
#define mod 1000000007
using namespace  std;
int n,m,q;
string str,str1,str2;
map<string,int> mp;
int exm;
int fa[200005];
int find(int root)
{
    if(fa[root]!=root)
        fa[root]=find(fa[root]);
    return fa[root];
}
void unit(int a,int b)
{
    int aa=find(a);
    int bb=find(b);
    if(aa!=bb)
    {
        fa[aa]=bb;
    }
}
int main()
{
    scanf("%d %d %d",&n,&m,&q);
    for(int i=1; i<=n; i++)
    {
        cin>>str;
        mp[str]=i;
        fa[i]=i;
        fa[i+n]=i+n;
    }
    for(int i=1; i<=m; i++)
    {
        cin>>exm>>str1>>str2;
        if(exm==1)
        {
            if(find(mp[str1])==find(mp[str2]+n))
                printf("NO\n");
            else
            {
                if(find(mp[str2])==find(mp[str1]+n))
                    printf("NO\n");
                else
                {
                    printf("YES\n");
                    unit(mp[str1],mp[str2]);
                    unit(mp[str1]+n,mp[str2]+n);
                }

            }
        }
        else
        {
            if(find(mp[str1])==find(mp[str2]))
                printf("NO\n");
            else
            {
                if(find(mp[str1]+n)==find(mp[str2]+n))
                    printf("NO\n");
                printf("YES\n");
                unit(mp[str1],mp[str2]+n);
                unit(mp[str1]+n,mp[str2]);
            }
        }
    }
    for(int i=1; i<=q; i++)
    {
        cin>>str1>>str2;
        if(find(mp[str1])==find(mp[str2])&& find(mp[str1]+n)==find(mp[str2]+n) &&
                find(mp[str1])!=find(mp[str2]+n) && find(mp[str1]+n)!=find(mp[str2]))
            printf("1\n");
        else
        {
            if(find(mp[str1])!=find(mp[str2])&& find(mp[str1]+n)!=find(mp[str2]+n) &&
                    find(mp[str1])==find(mp[str2]+n) && find(mp[str1]+n)==find(mp[str2]))
                printf("2\n");
            else
                printf("3\n");
        }
    }
    return 0;
}